package mypkg.lambda;

/**
 * ׻η׻
 *
 * ׻ݤ˷׻줿ͤǤϤʤ׻֤
 * פʾǤ. Υ饹Ϥξݻ.
 */
public class ResultValue {

	private LExpr value;    // Υ
	private int stepCount;  // ȤʤޤǤδ
	private long time;      // ߥñ̤ν׻

	/**
	 * ٤Ƥξꤷƥ֥Ȥ.
	 *
	 * @param value Υ
	 * @param stepCount ȤʤޤǤδ
	 * @param time ߥñ̤ν׻
	 */
	public ResultValue(LExpr value, int stepCount, long time) {
		this.value = value;
		this.stepCount = stepCount;
		this.time = time;
	}

	/**
	 * ׻줿ͤꤷƥ֥Ȥ.
	 *
	 * @param value Υ
	 */
	public ResultValue(LExpr value) {
		this(value, 0, 0);
	}

	/**
	 * ǥեȥ󥹥ȥ饯
	 */
	public ResultValue() {
		this(null, 0, 0);
	}

	/**
	 * ׻ߤtrue֤.
	 */
	public boolean halted() { return value != null; }

	/**
	 * ׻줿Υ֤.
	 */
	public LExpr getValue() { return value; }

	/**
	 * ȤʤޤǤδ֤.
	 */
	public int getStepCount() { return stepCount; }

	/**
	 * ߥñ̤ν׻֤֤.
	 */
	public long getTime() { return time; }

	/**
	 * Ƚ׻֤򼨤ʸ֤.
	 */
	public String observedData() {
		StringBuffer sb = new StringBuffer();
		sb.append(stepCount).append(" step(s) [");
		sb.append(getTimeMillis()).append("ms]");
		return sb.toString();
	}

	/**
	 * ߥñ̤ν׻֤ɽʸ֤.
	 */
	private String getTimeMillis() {
		StringBuffer sb = new StringBuffer();
		sb.append(time);
		switch (sb.length()) {
		case 1:
			sb.insert(0, "0.00");
			break;
		case 2:
			sb.insert(0, "0.0");
			break;
		case 3:
			sb.insert(0, "0.");
			break;
		default:
			sb.insert(sb.length()-3, ".");
			break;
		}
		return sb.toString();
	}
}
