package mypkg.lambda;

import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
 * g[Xo͏̊Ǘ
 *
 * ̃NX̓_vZIuWFNg쐬g[XLw̏o
 * ֏o͂@\. _̏o͌`͕GȂ̂ł̃NX̓_
 * 𕶎ɕϊ@\͎OɊ҂.
 */
public class TraceInfo {

	// ------------------------------------------------------------------
	// ̃NXXbhZ[tłKv͂ȂƎv邪, Kv
	// Ȃꍇ͏CKvɂȂ. Ԃ ThreadLocal gƊȒP.
	// ------------------------------------------------------------------

	private List infoList;    // g[X̋L^
	private List exprList;    // _
	private boolean verbose;  // g[Xoׂ͂Ȃtrue

	// ȖߒŌ̐K`vZĂ鎞̃g[X͎̂Ă邱ƂɂȂ.
	// ̃X^bN͎̂Ă\̂TraceInfovbV, |bv鎞
	// wɏ]ăg[Xۑ邩ǂ𐧌䂷.
	private static LinkedList stack = new LinkedList();  // vfTraceInfo

	/**
	 * ̃NX̃IuWFNgԂ.
	 */
	public static TraceInfo getInstance() {
		if (stack.size() <= 0)
			stack.addFirst(new TraceInfo());
		return (TraceInfo)stack.getFirst();
	}

	/**
	 * RXgN^
	 */
	private TraceInfo() {
		infoList = new ArrayList();
		exprList = new ArrayList();
		verbose = false;
	}

	/**
	 * g[Xo͏̏܂͍ď
	 */
	public void init(boolean verbose) {
		this.verbose = verbose;
		this.infoList.clear();
		this.exprList.clear();
	}

	/**
	 * g[Xoׂ͂ȂtrueԂ.
	 * ̃NX̓g[Xoׂ͂ǂ𔻒肵Ȃ. ̃\bh
	 * init()Ŏw肳ꂽԂł.
	 */
	public boolean isVerbose() { return verbose; }

	/**
	 * g[XɊ܂܂郉_XgŕԂ.
	 * ̃NXɂ͕ւ̕ϊ@\͂Ȃ.
	 * ̃\bhĂяoNXɂ͕ϊ@\Ɖ肵Ă̋@\
	 * 񋟂.
	 */
	public List getExprList() {
		return exprList;
	}

	/**
	 * g[Xo͂.
	 * Q̔z getExprArray() ̕Ԃl𕶎ɕϊ_
	 * łȂ΂ȂȂ. ꂪׂʒu͂̃NXmĂ.
	 *
	 * @param out o͐
	 * @param exprArray getExprArray() ̕Ԃl𕶎ɕϊ_
	 */
	public void print(PrintWriter out, String exprArray[]) {
		int index = 0;
		for (int n = 0; n < infoList.size(); n++) {
			Printer pr = (Printer)infoList.get(n);
			index = pr.print(out, exprArray, index);
		}
	}

	/**
	 * K`̔reduce()̎sʂ󃊃XgǂŌ܂.
	 * ăg[Xo͂Ăꍇɂ͐K`ꂽ̍Ō
	 * g[Xʂł. ̖ʂȂߐVTraceInfog.
	 */
	public static TraceInfo push() {
		TraceInfo newtrinf = new TraceInfo();
		newtrinf.verbose = true;   // push()ƂƂ verbose = true
		stack.addFirst(newtrinf);
		return newtrinf;
	}

	/**
	 * ^ꂽIuWFNgẽIuWFNgɃRs[.
	 *
	 * @param copy VTraceInfoTraceInfoɃRs[ׂȂtrue
	 */
	public static TraceInfo pop(boolean copy) {
		TraceInfo newtrinf = (TraceInfo)stack.removeFirst();
		TraceInfo orgtrinf = (TraceInfo)stack.getFirst();
		if (copy) {
			orgtrinf.infoList.addAll(newtrinf.infoList);
			orgtrinf.exprList.addAll(newtrinf.exprList);
			newtrinf.infoList.clear();
			newtrinf.exprList.clear();
		}
		return orgtrinf;
	}

	/**
	 * ȖÕ_̃g[XL^.
	 */
	public void appendTarget(Object expr, int level, String msg) {
		exprList.add(expr);
		infoList.add(new ArgInfo(level, msg));
	}

	/**
	 * Ȗ񌋉ʂ̃_̃g[XL^.
	 */
	public void appendArray(Object array[], int level, String msg) {
		if (array.length <= 0)
			return;
		for (int n = 0; n < array.length; n++)
			exprList.add(array[n]);
		infoList.add(new ValueInfo(array, level, msg));
	}

	/**
	 * Ȗ񌋉ʂ̃_̃g[XL^.
	 */
	public void appendList(List list, int level, String msg) {
		if (list.size() <= 0)
			return;
		for (int n = 0; n < list.size(); n++)
			exprList.add(list.get(n));
		infoList.add(new ValueInfo(list, level, msg));
	}

	/**
	 * Ȗ񌋉ʂ̃_P̃g[XL^.
	 */
	public void appendResult(Object expr, int level, String msg) {
		if (expr == null)
			return;
		exprList.add(expr);
		infoList.add(new ValueInfo((List)null, level, msg));
	}

	/**
	 * Zʂ̃g[XL^.
	 */
	public void appendRedex(Object redex, int level, String msg) {
		exprList.add(redex);
		infoList.add(new SubstInfo(level, msg));
	}

	/*----------------------------------------------------------------*/

	/**
	 * 󋵂Ƃ̃g[XʂɈ߂̃C^tF[X
	 */
	private interface Printer {
		int print(PrintWriter out, String exprArray[], int index);
	}

	/**
	 * ȖÕ_̃g[XL^NX
	 */
	private class ArgInfo implements Printer {
		private int level;
		private String msg;
		ArgInfo(int level, String msg) {
			this.level = level;
			this.msg = msg;
		}
		public int print(PrintWriter out, String exprArray[], int index) {
			for (int n = 0; n < level; n++)
				out.print("  ");
			out.print(exprArray[index++]);
			if (msg != null && msg.length() > 0)
				out.print("  -- " + msg);
			out.println();
			return index;
		}
	}

	/**
	 * Ȗ񌋉ʂ̃_̃g[XL^NX
	 */
	private class ValueInfo implements Printer {
		private Object array[];
		private List list;
		private int level;
		private String msg;
		ValueInfo(Object array[], int level, String msg) {
			this.array = array;
			this.level = level;
			this.msg = msg;
		}
		ValueInfo(List list, int level, String msg) {
			this.list = list;
			this.level = level;
			this.msg = msg;
		}
		public int print(PrintWriter out, String exprArray[], int index) {
			for (int n = 0; n < level; n++)
				out.print("  ");
			out.print("-> ");
			if (array == null && list == null) {
				out.print(exprArray[index++]);
			} else if (list != null) {
				for (int n = 0; n < list.size(); n++) {
					if (n > 0)
						out.print("; ");
					out.print(exprArray[index++]);
				}
			} else {
				for (int n = 0; n < array.length; n++) {
					if (n > 0)
						out.print("; ");
					out.print(exprArray[index++]);
				}
			}
			if (msg != null && msg.length() > 0)
				out.print("  -- " + msg);
			out.println();
			return index;
		}
	}

	/**
	 * Zʂ̃g[XL^NX
	 */
	private class SubstInfo implements Printer {
		private int level;
		private String msg;
		SubstInfo(int level, String msg) {
			this.level = level;
			this.msg = msg;
		}
		public int print(PrintWriter out, String exprArray[], int index) {
			for (int n = 0; n < level; n++)
				out.print("  ");
			out.print(exprArray[index++]);
			if (msg != null && msg.length() > 0)
				out.print("  -- " + msg);
			out.println();
			return index;
		}
	}
}
