package mypkg.lambda;

import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeSet;
import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;
import java.lang.reflect.Constructor;

/**
 * 
 *
 * Ȥ
 *     ѿ |  | ؿŬ
 * Ǥ, Υ饹Ϥ̤˼갷ݥ饹Ǥ.
 *
 *         ֥饹         
 *   ----------------------------------------------
 *     ѿ        Variable             x
 *       Abstraction  x.M ޤ \x.M
 *     ؿŬ    Application          MN
 *
 * Υ饹Υ֥饹ΰ̣, ĥ꡼ɽΥΡɤ
 * бǡǤ.
 *
 * 󶡤륤󥿥եǽˤ
 *     Ǻ, , ͳѿõ, Ʊθ, ¾
 * .
 * ֥饹 (ѿݡؿŬ) ٤ǽ, 嵭Υ
 * եǽΥ֥饹ͭνǤ.
 * Υ饹ϼѼԤؤpublic󥿡եȥ֥饹ؤprotected
 * 󥿡ե󶡤뤬, ֥饹Τμ㴳μޤ.
 *
 * ׻򼨤.
 *
 *     // ʸΥ
 *     String s = in.readLine();
 *
 *     // LExprFactory Ȥäʸ󤫤Ѵ
 *     // factory ֥ȤκˤĤƤϾɬפǤ뤬
 *     // ٤Ȥ򵤤ˤʤ
 *     //     LExprFactory factory = new MathLExprFactory(null, null);
 *     // ȤƤ褤. ̤Υ󥿥ե LExprHandler Ȥ
 *     // Υ饹ξܺ٤򵤤ˤ˥׻¹ԤǤ.
 *     LExpr expr = factory.create(s);
 *
 *     // ƥåפκǺԤ
 *     LExpr value = expr.reduce();
 *     System.out.println(value);
 *
 *     // ƥåפΤ٤Ƥδ̤
 *     LExpr array[] = expr.reduceAll();
 *     for (int n = 0; n < array.length; n++)
 *         System.out.println("[" + (n+1) + "] " + array[n]);
 *
 * ƥץѥƥ
 * ~~~~~~~~~~~~~~~~~~
 * ǥեȤνϷ lambdacalc.format
 *     ̤ΥɤɽǽϤ뤫ꤹ.
 *       ǽ
 *           abbrev: ǤʷʿŪɽ [] xy.xyz
 *           math:   ʷ̾οŪɽ [] x.y.xyz
 *           proper: ǡ¤βŪɽ [] x.(y.((xy)z))
 *       ǥե: abbrev
 *      [] properϳ̤¿Ѥǡ¤β뤬mathϤǤ
 *             ̤άɽǤ. abbrev¿ѿؿɽ
 *             ˤ.
 */
public abstract class LExpr implements Cloneable {

    // ------------------------------------------------------------------
    // Υ饹åɥդǤɬפϤʤȻפ뤬, ⤷ɬפ
    // ʤä serialno ʤɤĤѿкɬפǤ.
    // ------------------------------------------------------------------

	/*-------------------------------------------------------------------*/
	// 󥿥ե

	/**
	 * Σƥå׺Ǻ -- Ѵ
	 *
	 * @return ƥå׺Ǻ̤Υ
	 */
	public LExpr reduce() {
		return reduce(0);
	}

	/**
	 * Σƥå״ -- Ѵ
	 * Υ᥽åɤϺǺǤϤʤ٤Ƥδ̤֤.
	 *
	 * @return  ƥå״̤ (ǤηLExpr)
	 */
	public LExpr[] reduceAll() {
		List list = reduceAll(0);
		return (LExpr[])list.toArray(new LExpr[list.size()]);
	}

	/**
	 *  M[x:=N]
	 * Υ(M)β(param)˼°(arg).
	 *
	 * @param param ѿ (x)
	 * @param arg   ° (N)
	 * @return  黻̤
	 */
	public LExpr substitute(String param, LExpr arg) {
		return substitute(param, arg, 0);
	}

	/**
	 * ͳѿν֤.
	 *
	 * @return Υ֥Ȥμͳѿν
	 */
	public Set freeVariables() {
		Set set = new TreeSet();
		this.gatherFreeVars(set);
		return set;
	}

	/**
	 * Υ֥ȤΥȦƱͤʤtrue֤.
	 *
	 * @param expr оݤΥ
	 * @return Ʊͤʤtrue
	 */
	public boolean isAlphaEquivalent(LExpr expr) {
		return this.isEquivalent(expr, new LinkedList(), 0);
	}

	/**
	 * ưŪʦѴǺ줿ѿ̾Ŭѿ֤.
	 * ѴȤ«ѿ̾դǤx.xxy.yyѴ뤳Ȥ
	 * ̣.
	 *  $08.$10.$10 -> x.y.y
	 *
	 * @return Ŭѿ֤줿
	 */
	public LExpr reshape() {
		return reshapeThis();
	}

	/**
	 * Υ֥Ȥλʸɽ֤.
	 *
	 * @param format Ϸμ̾
	 * @param uselambda ʸ \ ǤϤʤ LExpr.LAMBDA 
	 * @return ʸɽ
	 */
	public String getString(String format, boolean uselambda) {
		if (ABBREVFORMAT.equals(format))
			return simplify(toAbbrevString(uselambda));
		if (MATHFORMAT.equals(format))
			return toMathString(uselambda);
		if (PROPERFORMAT.equals(format))
			return toProperString(uselambda);
		throw new IllegalArgumentException("unknown format: " + format);
	}

	/**
	 * Υ֥Ȥʸɽ֤.
	 *
	 * @return ʸɽ
	 */
	public String toString() {
		String fmt = System.getProperty(DEFFORMATKEY, ABBREVFORMAT);
		return getString(fmt, false);
	}

	/**
	 * ѿɽ֥Ȥ.
	 * ƥץѥƥ mypkg.lambda.LExpr.var.class ꤵƤ
	 * ͤ򥯥饹̾Ȳꤷ, ꤬ʤ mypkg.lambda.Variable 
	 * 饹̾Ȥ.
	 *
	 * @param name ѿ̾
	 * @return ѿɽ
	 */
	public static LExpr getInstance(String name) {
		return createObject(VAR_ID,
			new Class[]{ String.class },
			new Object[]{ name }
		);
	}

	/**
	 * ݤɽ֥Ȥ.
	 * ƥץѥƥ mypkg.lambda.LExpr.abs.class ꤵƤ
	 * ͤ򥯥饹̾Ȳꤷ, ꤬ʤ mypkg.lambda.Abstraction
	 * 򥯥饹̾Ȥ.
	 *
	 * @param parameter ̾
	 * @param body ؿ
	 * @return ݤɽ
	 */
	public static LExpr getInstance(String parameter, LExpr body) {
		return createObject(ABS_ID,
			new Class[]{ String.class, LExpr.class },
			new Object[]{ parameter, body }
		);
	}

	/**
	 * ؿŬѤɽ֥Ȥ.
	 * ƥץѥƥ mypkg.lambda.LExpr.app.class ꤵƤ
	 * ͤ򥯥饹̾Ȳꤷ, ꤬ʤ mypkg.lambda.Application
	 * 򥯥饹̾Ȥ.
	 *
	 * @param func ؿ
	 * @param arg °
	 * @return ؿŬѤɽ
	 */
	public static LExpr getInstance(LExpr func, LExpr arg) {
		return createObject(APP_ID,
			new Class[]{ LExpr.class, LExpr.class },
			new Object[]{ func, arg }
		);
	}

	/**
	 * -redexɽ֥Ȥ.
	 * ƥץѥƥ mypkg.lambda.LExpr.redex.class ꤵƤ
	 * ͤ򥯥饹̾Ȳꤷ, ꤬ʤ mypkg.lambda.BetaRedex 
	 * 饹̾Ȥ.
	 * ֤륪֥Ȥ LExprǤϤ뤬ѿ, , ؿŬѤ
	 * 褦˥ĥ꡼ΥΡɤȤʤ뤳ȤꤷƤʤ.
	 *
	 * @param body ؿ
	 * @param param 
	 * @param arg °
	 * @return -redexɽ
	 */
	public static LExpr getInstance(LExpr body, String param, LExpr arg) {
		return createObject(REDEX_ID,
			new Class[]{ LExpr.class, String.class, LExpr.class },
			new Object[]{ body, param, arg }
		);
	}

	/**
	 * Υ֥ȤΥԡ.
	 *
	 * @return Υ֥ȤΥԡ
	 */
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			// assert false;
			throw new IllegalStateException();
		}
	}

	/**
	 * ()Ѵ뤫ɤ椹.
	 *
	 * @param value true ʤЦѴ
	 */
	public static void suppressEtaConversion(boolean value) {
		noEtaConversion = value;
	}

	/*-------------------------------------------------------------------*/
	// ֥饹ǥХ饤ɤޤϼ٤ǽ

	/**
	 * Σƥå׺Ǻ -- Ѵ
	 * Υ᥽åɤϺǺ󤵤줿򣱸֤.
	 *
	 * Ѵ (׻ ⶶ p.65)
	 * 梪ϦѴ̣ΤȤ.
	 *
	 *        §                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N ʤ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N ʤ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N ʤ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * ȤФΥ֥(this)
	 *     ((a.b)c)((x.y)z)
	 * Ȥ
	 *     b((x.y)z)
	 * ֤.
	 *
	 * @param level ƵƽФ٥
	 * @return  ƥå׺Ǻ̤Υ (Ǥʤnull)
	 */
	protected LExpr reduce(int level) {
		return null;
	}

	/**
	 * Σƥå״ -- Ѵ
	 * Υ᥽åɤϺǺǤϤʤ٤Ƥδ̤֤.
	 *
	 * Ѵ (׻ ⶶ p.65)
	 * 梪ϦѴ̣ΤȤ.
	 *
	 *        §                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N ʤ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N ʤ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N ʤ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * ƥå״η̤ʣΤ, Υ᥽åɤList<LExpr>
	 * ֤ͤ. ȤФΥ֥(this)
	 *     ((a.b)c)((x.y)z)
	 * Ȥ
	 *     [b((x.y)z); ((a.b)c)y]
	 * ֤.
	 *
	 * ̤ʣϺǺƬǤȤʤ륢르ꥺȤʤä
	 * . ä뤿ˤΥ᥽åɤƤӽФϺǺ
	 * ̵̤ʷ׻άǤ.
	 * ٤Ƥδ̤뵡ǽ, ήǧ, ˡˤä
	 * ߤʤȤʤɤǧ뤿ѰդƤ.
	 *
	 * @param level ƵƽФ٥
	 * @return  ƥå״̤Υꥹ
	 */
	protected List reduceAll(int level) {
		// Υ᥽åɤη LExpr[] Ǥ٤֤ƤӽФ
		// ǽθ List Ȥ. Y-Combinator Ȥ׻Ǥϴñ
		// η֤ȯ.
		return null;
	}

	/**
	 * Σƥå״ -- -redexξ
	 * -redexȤ(x.M)NηΥ̣.
	 * Υ᥽åɤоݤ x.M Ǥ arg  N ȤƸƤӽФ.
	 * ֥饹ΥݤΤߤ null ǤϤʤ֤ͤ.
	 */
	protected LExpr reduceRedex(LExpr arg, int level) {
		//########## (A) (x.M)N  M[x:=N] ##########
		return null;
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N ͤ M 
	 *     ѿ, , ؿŬ
	 * ξʬƵ.
	 *  (ץߥ󥰸δ ٽ p.18)
	 *
	 *                                   
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  嵭ʳ            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N μͳѿǤϤʤȤ̣.
	 *  [2] ưŪ˦Ѵ뤳Ȥ. ѿ z Ϥޤä̾
	 *        Ф.
	 *
	 * @param param ѿ (x)
	 * @param arg   ° (N)
	 * @param level ƵƽФ٥
	 * @return  黻̤
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		return null;
	}

	/**
	 * Υ֥ȤΥ֥ȤȦƱͤʤtrue֤.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		return false;
	}

	/**
	 * ͳѿ򽸤.
	 * ͳѿ (ץߥ󥰸δ ٽ p.17)
	 *     FV(x) = {x}
	 *     FV(x.M) = FV(M) - {x}
	 *     FV(MN) = FV(M) OR FV(N)
	 */
	protected void gatherFreeVars(Set set) { }

	/**
	 * ͳѿ«ѿ̤٤Ƥѿ򽸤.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void gatherVars(Set set) { }

	/**
	 * бɽ򻲾Ȥѿ֤̾.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void replaceVars(Map map) { }

	/**
	 * Υ֥ȤѿʤФ֤̾.
	 * ξLExprѿexprѿǤ뤳Ȥɽ.
	 *     expr.variableName() != null
	 */
	protected String variableName() { return null; }

	/**
	 * Υ֥Ȥ x.M ʤФβ̾ x ֤.
	 * ξLExprѿexprݤǤ뤳Ȥɽ.
	 *     expr.parameterName() != null
	 */
	protected String parameterName() { return null; }

	/**
	 * Υ֥Ȥ x.M ʤФδؿ M ֤.
	 * ξLExprѿexprݤǤ뤳Ȥɽ.
	 *     expr.getBody() != null
	 */
	protected LExpr getBody() { return null; }

	/**
	 * Υ֥ȤؿŬ MN ʤФδؿ M ֤.
	 * ξLExprѿexprؿŬѤǤ뤳Ȥɽ.
	 *     expr.getFunction() != null
	 */
	protected LExpr getFunction() { return null; }

	/**
	 * Υ֥ȤؿŬ MN ʤФΰ N ֤.
	 * ξLExprѿexprؿŬѤǤ뤳Ȥɽ.
	 *     expr.getArgument() != null
	 */
	protected LExpr getArgument() { return null; }

	/**
	 * -redex (x.M)N δؿ(M)֤.
	 */
	protected LExpr getBodyOfRedex() { return null; }

	/**
	 * -redex (x.M)N β(x)֤.
	 */
	protected String getParamOfRedex() { return null; }

	/**
	 * -redex (x.M)N μ°(N)֤.
	 */
	protected LExpr getArgOfRedex() { return null; }

	/**
	 * Υ֥ȤChurchʤп֤ͤ.
	 * Ǥʤ IllegalStateException 򥹥.
	 * ChurchȤ sz.s(s((sz))) ηΥؤ.
	 */
	protected int getChurchNumeral(String succ, String zero) {
		throw new IllegalStateException();
	}

	/**
	 * ǤʷʿŪɽʸ֤.
	 *  xyz.xyz
	 */
	protected abstract String toAbbrevString(boolean uselambda);

	/**
	 * ʷʿŪɽʸ֤.
	 *  x.y.z.xyz
	 */
	protected abstract String toMathString(boolean uselambda);

	/**
	 * ĹʿŪɽʸ֤.
	 *  x.(y.(z.((xy)z)))
	 */
	protected abstract String toProperString(boolean uselambda);

	// true ʤЦѴ.
	protected static boolean noEtaConversion;

	/**
	 * Ѵ
	 *     (x.Mx)N = MN  x ! FV(M)
	 * Ǥ뤳Ȥθ
	 *     x.Mx = M
	 * ֤ǽǤ.
	 *
	 * ѿ null ֤.
	 * ݤΤؿŬѤǤApplication˰ѾǤʤ
	 * null ֤.
	 * ؿŬѤϱ¦μ̾ѿǤ뤳Ȥǧ¦μμͳ
	 * ѿǤʤȤǧƺ¦μ֤.
	 */
	protected LExpr etaConversion(String param) {
		return null;
	}

	/*-------------------------------------------------------------------*/
	// 

	/**
	 * οŪɽˤݤɽ
	 * []
	 *    εϻϤκݤˣʸǤ뤳Ȥꤹ. ä
	 *    ѤΥȾѤΥХåå˸ꤹ٤Ǥ.
	 */
	public static final String LAMBDA = "";

	/**
	 * ץѥƥ̾Υץե
	 */
	public static final String PREFIX = "lambdacalc.";

	// νϷϢ

	/** νϷꤹץѥƥ̾ */
	public static final String DEFFORMATKEY = PREFIX + "format";
	/** νϷǤʷʿŪɽȤץѥƥ */
	public static final String ABBREVFORMAT = "abbrev";
	/** νϷʷ̾οŪɽȤץѥƥ */
	public static final String MATHFORMAT = "math";
	/** νϷĹʿŪɽȤץѥƥ */
	public static final String PROPERFORMAT = "proper";

	/*-------------------------------------------------------------------*/
	// ѿ

	/**
	 * ꥢֹղäƥˡѿ̾뤿Υץե
	 * []
	 *    ѿ̾ͤɤɬפ˱«ѿ̾ΦѴԤ.
	 *    ʸϤѿ̾ΥץեȤѤ.
	 */
	private static final String VARPREFIX = "$";

    // ˡѿ̾뤿Υꥢֹ
    private static int serialno;

	/**
	 * ˡѿ̾ǽν
	 * ǦѴԤ˥ˡѿ̾Фǽɬפˤʤ.
	 * Υ᥽åɸƤӽФǤεǽ. äƷ׻뼰
	 * ѹŬʸƤӽФΥߥ󥰤Ȥʤ.
	 * ⤷ƤӽФʤäĹ̾ȤǷ׻
	 * 櫓ǤϤʤ.
	 */
	protected static void init() { serialno = 0; }

	/**
	 * ưŪʦѴΤѿ֥Ȥ.
	 */
	protected static LExpr uniqueVariable() {
		String ns = String.valueOf(++serialno);
		// ΥȤԤֹ2ʾȤ. 3ʾ.
		// 3ʾȤʤäαƶѿγƤѤ뤳ȤǤ
		// ̤ϰȤ.
		if (ns.length() == 1)
			ns = "0" + ns;
		return createObject(VAR_ID,
			new Class[]{ String.class },
			new Object[]{ VARPREFIX + ns }
		);
	}

	/**
	 * ѿ̾ΣʸܤȤƲǽʸʤtrue֤.
	 * ߤѿ̾λͤ
	 *     [a-zA-Z][0-9]*
	 * Ǥ. λͤϤΥ饹Υ֥饹ϥ饹λȤ
	 * ͭʤФʤʤ.
	 * λͤˤ
	 *     e1e2
	 * ѿe1e2ϢȤߤʤŪɽǽˤʤ.
	 *
	 * @param c Ƚꤹ룱ʸ
	 * @return  ѿ̾ΣʸܤȤƲǽʤtrue
	 */
	protected static boolean isVariableStart(int c) {
		return isVarStart(c);
	}

	/**
	 * ѿ̾ηtrue֤.
	 * Υ饹Υ֥饹ǥ֥ȺΥåǽȤƻȤ.
	 *
	 * @param name ѿ̾
	 * @return ѿ̾ηtrue
	 */
	protected final boolean checkVariable(String name) {
		if (name == null || name.length() <= 0)
			return false;
		int off = 0;
		if (name.startsWith(VARPREFIX))
			off = VARPREFIX.length();
		else if (isVarStart(name.charAt(0)))
			off = 1;
		else
			return false;
		for ( ; off < name.length(); off++)
			if (!Character.isDigit(name.charAt(off)))
				return false;
		return true;
	}

	/**
	 * ѿ̾ΣʸܤȤƲǽʸʤtrue֤.
	 * ߤλͤϱѾʸޤϱʸΤ줫Ǥ. θ˿
	 * ³Ȥ.
	 */
	private static boolean isVarStart(int c) {
		// Character.isLowerCase(), Character.isUpperCase() Ȥʤ.
		// [] Character.isLowerCase((char)'') == true
		return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z';
	}

	// ¤ӤѿȤƤդ路ȤʤäƤ.
	private static final String Vchars =
		"xyzuvwpqrstabcdefghijklmno" + "XYZUVWPQRSTABCDEFGHIJKLMNO";
	private static final int Vcount = Vchars.length();

	/**
	 * ưŪʦѴǺ줿ѿ̾Ŭѿ֤.
	 *  $08.$10.$10 -> x.y.y
	 */
	private LExpr reshapeThis() {
		// ȤƤѿ̾set˽.
		Set set = new TreeSet();
		this.gatherVars(set);
		int vcount = 0;
		for (Iterator i = set.iterator(); i.hasNext(); )
			if (((String)i.next()).startsWith(LExpr.VARPREFIX))
				vcount++;
		if (vcount <= 0)
			return this;
		// Ѵ˺줿ѿ̾ʸ֤ǽɤĴ٤.
		if (set.size() > Vcount || vcount > Vcount) {
			//throw new IllegalArgumentException("Sorry, too complex");
			return this;  // Ūñ˵褦ʤΤ.
		}
		Map map = new HashMap();
		int index = 0;
		for (Iterator i = set.iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			if (!name.startsWith(LExpr.VARPREFIX))
				continue;
			String newname = null;
			while (index < Vcount) {
				newname = String.valueOf(Vchars.charAt(index++));
				if (!set.contains(newname))
					break;
			}
			if (index >= Vcount) {
				//throw new IllegalArgumentException("Sorry, too complex");
				return this;  // ޤ˵. (Y Combinator Ȥʤ)
			}
			map.put(name, newname);
		}
		// map򻲾Ȥѿ֤̾.
		LExpr newexpr = (LExpr)this.clone();
		newexpr.replaceVars(map);
		return newexpr;
	}

	/*-------------------------------------------------------------------*/
	// νϷ

	private static final String Waste1 = ".\\", Waste2 = "." + LAMBDA;

	/**
	 * Ϥʸ򲼵Τ褦˽.
	 *                 
	 *   -------------------------------
	 *     x.y.x(xy) => xy.x(xy)
	 *     \x.\y.x(xy)   => \xy.x(xy)
	 *
	 * Τ褦ʷŪʽɤʤľʸФǤ
	 * Ūʬ굤ڤǤ. ^_^;)
	 */
	protected final String simplify(String s) {
		if (s.indexOf(Waste1) < 0 && s.indexOf(Waste2) < 0)
			return s;
		StringBuffer sb = new StringBuffer(s);
		for ( ; ; ) {
			int off = sb.indexOf(Waste1);
			if (off < 0)
				off = sb.indexOf(Waste2);
			if (off < 0)
				break;
			sb.delete(off, off+2);
		}
		return sb.toString();
	}

	/**
	 * ɬȽꤷͿ줿ʸ̤Ǥ.
	 * ɬפΤʤȤ
	 *   Ĥѿξ
	 *   Ǥ˳̤ǤƤ
	 * Ȥ.
	 * Ȥ
	 *     "(ab)"  "((ab)(cd))"
	 * ʤɤϤǤ˳̤ǤƤ뤬
	 *     "(ab)(cd)"
	 * ϳ̤ǤƤʤȤդ뤳.
	 */
	protected final String parenthesize(String es) {
		if (es.length() < 2 || checkVariable(es))
			return es;  // ñѿξϽ
		if (es.charAt(0) == '(' && es.charAt(es.length()-1) == ')') {
			int level = 1;
			int off = 1;
			for (int end = es.length()-1; level > 0 && off < end; off++) {
				int c = es.charAt(off);
				if (c == '(')
					level++;
				if (c == ')')
					level--;
			}
			if (level > 0)
				return es;  // Ǥ˳̤ǤƤ.
		}
		return "(" + es + ")";
	}

	/*-------------------------------------------------------------------*/
	// 󥹥󥹲

	// Υ֥饹μ̻
	private static final String
		VAR_ID = "var", ABS_ID = "abs", APP_ID = "app", REDEX_ID = "redex";

	// ǥեȤΥ֥饹̾
	private static final String DEFCLASS[][] = {
		{ VAR_ID, "mypkg.lambda.Variable" },
		{ ABS_ID, "mypkg.lambda.Abstraction" },
		{ APP_ID, "mypkg.lambda.Application" },
		{ REDEX_ID, "mypkg.lambda.BetaRedex" },
	};

	// Constructor򥭥å夹ޥå (ϥΥ֥饹μ̻)
	private static Map constructorMap = new HashMap();

	/**
	 * ̻Ҥб֥Ȥ.
	 */
	protected static LExpr createObject(String id, Class types[],
			Object args[]) {
		Constructor constructor = (Constructor)constructorMap.get(id);
		try {
			if (constructor == null) {
				Class c = Class.forName(getSubclassName(id));
				constructor = c.getDeclaredConstructor(types);
				constructorMap.put(id, constructor);
			}
			return (LExpr)constructor.newInstance(args);
		} catch (Exception e) {
			e.printStackTrace();
			throw new IllegalStateException("check env");
		}
	}

	/**
	 * ֥饹μ̻Ҥ饵֥饹̾ؤѴ
	 */
	private static String getSubclassName(String id) {
		String propkey = LExpr.class.getName() + "." + id + ".class";
		String className = System.getProperty(propkey);
		if (className != null && className.length() > 0)
			return className;
		for (int n = 0; n < DEFCLASS.length; n++)
			if (id.equals(DEFCLASS[n][0]))
				return DEFCLASS[n][1];
		throw new IllegalStateException("invalid subclass ID: " + id);
	}

	/*-------------------------------------------------------------------*/
	// ¾

	private LinkedList workstack;

	/**
	 * ٤Ƥδ̤ reduceAll() Ƿ̤ꥹȤ˵.
	 * ñ add() ʤͳϽʣɤǤ.
	 * ʣ뤫ɤβϤ񤷤ΤǸΨˤ̵
	 * å.
	 * ʤȤѴԤȽʣ̤ФƤ褦Ǥ.
	 */
	protected final void appendLExpr(List list, LExpr expr) {
		if (workstack == null)
			workstack = new LinkedList();
		for (int n = 0; n < list.size(); n++) {
			workstack.clear();
			if (expr.isEquivalent((LExpr)list.get(n), workstack, 0))
				return;
		}
		list.add(expr);
	}
}
