package mypkg.lambda;

import java.util.Set;
import java.util.Map;
import java.io.PrintWriter;

/**
 * ׻󥿥ե
 *
 * ׻饹LambdaCalculusѾ벼Ƥ.
 *   ʸ󤫤ؤѴ
 *   η׻̤ν
 *   η׻
 *   ޥδ
 *   ֤δ
 *
 * ޥȤʣʥϤôڸΤ˥̾դ
 * ̾ǻȤǽؤ.
 * ׻򳫻Ϥˤ٤ƤΥޥȤŸƤޤ
 * ׻ˤϤޤäƶͿʤ.
 *
 * Υ󥿥եϥ(LExpr)μۤȤɬפȤ˥
 * ׻ԤȤŪȤ߷פƤ.
 */
public interface LExprHandler {

	/**
	 * ʸLExprΥѴ.
	 *
	 * @param s Ѵоݤʸ
	 * @return   (LExpr)
	 */
	public LExpr createLExpr(String s);

	/**
	 * LExprΥϤ.
	 * դ.
	 * Ϥ줿ƱȤ.
	 *   ˤȾѥХåå夫ѥ()Ȥ.
	 * ̤ޥ֤꤬̾äƤϤ줿
	 *   ޥȤƤʤХޥ֤̾ʤ.
	 * false  0 ϤޤäƱʤΤϤ줿
	 *   Ǥ򤹤.
	 * Τ褦ʻͤ˰ȤϤ줿Ϳɬ
	 * .
	 *
	 * @param out     
	 * @param expr    оݤΥ
	 * @param s       Ϥ줿 (ϻξ򻲾Ȥ뤿)
	 * @param verbose trueʤе줿ȥ졼 (normalize())
	 */
	public void print(PrintWriter out, LExpr expr, String s, boolean verbose);

	/*------------------------------------------------------------------*/
	// η׻

	/**
	 * Υ.
	 *
	 * @param expr ׻оݤΥ
	 * @param verbose trueʤХΥȥ졼򵭲
	 * @return  Υ, , ׻֤ݻ륪֥
	 *          ׻ߤʤϥnullΥ֥
	 *          Υnullʤnull
	 */
	public ResultValue normalize(LExpr expr, boolean verbose);

	/**
	 * Τ٤ƤΣƥå״̤֤.
	 * ƥå״η̤ʣΤ, Υ᥽åɤLExpr[]
	 * ֤ͤ.
	 *
	 * @param expr  оݤΥ
	 * @return  ƥå״󤵤줿
	 */
	public LExpr[] step(LExpr expr);

	/**
	 * Ϳ줿򣱥ƥå׺Ǻ󤷤֤.
	 * step()Ȥΰ㤤ϺǺ׻뤳ȤǤ.
	 * normalize()ϤΥ᥽åɤãޤǷ֤̤֤.
	 *
	 * @param expr оݤΥ
	 * @return Ǻ󤵤줿 (Ǥʤnull֤.)
	 */
	public LExpr convert(LExpr expr);

	/**
	 * M[x:=N] ޤ [N/x]M ηʸᤷ黻η̤֤.
	 *
	 * @param s Ѵоݤʸ ("M[x:=N]" ޤ "[N/x]M")
	 * @return  黻̤Υ
	 */
	public LExpr substitute(String s);

	/**
	 * Ϳ줿μͳѿν֤.
	 *
	 * @param expr ĴоݤΥ
	 * @return  μͳѿν
	 */
	public Set freeVariables(LExpr expr);

	/*------------------------------------------------------------------*/
	// ޥδ

	/**
	 * ޥ.
	 *
	 * @param name  ޥ̾
	 * @param value 
	 */
	public void defineMacro(String name, String value);

	/**
	 * Ϳ줿бɽΥޥ.
	 *
	 * @param map ޥ̾ͤбɽ
	 */
	public void defineMacros(Map map);

	/**
	 * ޥΰϤ.
	 *
	 * @param out 
	 * @param msg ˽Ϥ (nullʤнϤʤ)
	 */
	public void printMacros(PrintWriter out, String msg);

	/*------------------------------------------------------------------*/
	// ֤δ

	/**
	 * ξͤꤹ.
	 *
	 * @param maxSteps ξ
	 */
	public void setMaxSteps(int maxSteps);

	/**
	 * ꤵƤξ֤ͤ.
	 *
	 * @return ξ
	 */
	public int getMaxSteps();

	/**
	 * νϷꤹ.
	 * LExpr.MATHFORMATʤɤ줿ʸʬŪ˰פ뤳.
	 *
	 * @param s  νϷ̾ (ʬ)
	 */
	public void setFormat(String s);

	/**
	 * νϷѥ᡼ʸ֤.
	 *
	 * @param indent ʸ֤륤ǥʸ
	 */
	public String getFormatCaption(String indent);

	/**
	 * νϤޥ̾Ѵ뤫ɤꤹ.
	 *
	 * @param value  trueʤнϤޥ̾Ѵ
	 */
	public void setReshape(boolean value);

	/**
	 * ()Ѵ뤫ɤ椹.
	 *
	 * @param suppress trueʤЦѴ
	 */
	public void suppressEtaConversion(boolean suppress);

	/*------------------------------------------------------------------*/
	/**
	 * ץѥƥ̾Υץե
	 */
	public static final String PREFIX = LExpr.PREFIX;
}
