package mypkg.lambda;

import mypkg.lambda.util.PropertiesHandler;
import mypkg.lambda.util.CommentRemover;
import mypkg.lambda.util.ResourceReader;
import java.io.Reader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.StringReader;
import java.io.Writer;
import java.io.FileWriter;
import java.io.OutputStreamWriter;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.IOException;
import java.io.EOFException;
import java.util.Properties;
import java.util.Enumeration;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.Set;
import java.util.LinkedHashMap;
import java.lang.reflect.Constructor;

/**
 * ʤ׻Υ󥿥ץ꥿
 *
 * Υ饹ϼΤ褦Ϥ.
 *
 *   ŪɽΥϤ, ԤäƷ̤Ϥ.
 *   ޥǤƥ׻˥ޥŸǤ.
 *   ޥɤ¹Ԥ.
 *
 * ν, EOFФޤǷ֤.
 *
 * δˡˤ
 *
 *       ˡ            νλ  
 *   -----------------------------------------------------------------------
 *     ޤǴ        ;             (\xy.xy)(\w.ww);
 *     ƥå״              ->            (\x.y)((\x.xx)(\x.xx))->
 *     ƥå׺Ǻ          =>            (\x.y)((\x.xx)(\x.xx))=>
 *
 * νλ(׻)ǽǤ.
 * νλǷ׻򳫻ϤͤʣԤΥϤˤԹ
 * 褤.
 * νλϥץѥƥ
 *     lambdacalc.endofexp, lambdacalc.endofexp2, lambdacalc.endofexp3
 * ѹǤ.
 * Ϥηϥץѥƥlambdacalc.formatλ˽.
 *
 * ϤôڸΤ˥ޥѤǽǤ.
 * ޥȤϥ̾դ̾ǻȤǽؤ.
 * η
 *     ޥ̾ =  ;
 * Ǥ. ʣԤΥ˽λ ; ׵᤹.
 *      [] Y = \f.(\x.f(xx))(\x.f(xx));
 * ׻򳫻Ϥˤ٤ƤΥޥȤŸƤޤ׻
 * ˤϤޤäƶͿʤ.
 *
 * ޥɤˤưѥ᡼ꡦȤ׻Ūʵǽޤޤ
 * Ƥ. ޥɤ : ǻϤޤԤǼ¹Ԥ򳫻Ϥ.
 * إפǰϤǤ.
 * ޥ :example Ǥ򻲾ȤǤ.
 *
 * ղŪʵǽȤ, 桼ץѥƥեɤ߹ư
 * ȿǤ뤳ȤǤ. ˤΥץѥƥեθ뵡ǽ
 * äƤ.
 *
 * ƥץѥƥ
 * ~~~~~~~~~~~~~~~~~~
 * ϻνλ lambdacalc.endofexp (endofexp2, endofexp3)
 *     ŪɽΥϤ, νλɬפ.
 *     ץѥƥ lambdacalc.endofexp ϼνλ.
 *      [ջ] ѻǻϤޤʤ.
 * ޥ̾ͤζڤ국 lambdacalc.macrodef
 *   ʣʸεǤʤ.
 *   ǥե: =
 * ޥȤγϵ lambdacalc.macro1
 *   ʣʸεǤʤ.
 *   ǥե: <
 * ޥȤνλ lambdacalc.macro2
 *   ʣʸεǤʤ.
 *   ǥե: >
 */
public class LambdaCalculus {

	// Υ饹ϥ׻Υɥ饤ФȤʤ뤳ȤǤ. Ĥޤ
	// 桼Ȥõǽʬô׻ LExprHandler ˰Ѿ.
	// Υ饹¸ΤϲΥ饹Ǥ.
	// mypkg.lambda.LExprHandler           ׻󥿥ե
	// mypkg.lambda.LExpr                  ɽݥ饹
	// mypkg.lambda.ResultValue            ׻η׻
	// mypkg.lambda.util.PropertiesHandler ץѥƥ
	// mypkg.lambda.util.CommentRemover    ȤReader
	// mypkg.lambda.util.ResourceReader    ꥽ɹѤReader

	private LExprHandler handler;   // ׻Ѿ륪֥

	private BufferedReader reader;  // 
	private PrintWriter writer;     // 
	private boolean verbose;        // trueʤХȥ졼
	private boolean prompt;         // trueʤХץץȽ

	private final String endMark;       // νλ normalize()
	private final String stepMark;      // νλ step()
	private final String lmstepMark;    // νλ convert()
	private final String macroDef;      // ޥζڤ국
	private final String macroStart;    // ޥȤγϵ
	private final String macroEnd;      // ޥȤνλ

	// ֤ѹɬפΤʤץѥƥ
	private static final String cmdMark = ":";
	private static final String blockComment1 = "{-";
	private static final String blockComment2 = "-}";
	private static final String lineComment = "--";

	// ޥ
	private static final String
		PRVAL = "print", MAXSTEPS = "step", ETACNV = "Eta", LOAD = "load",
		PRMACRO = "macro", FORMAT = "format", RESHAPE = "reshape",
		TRACE = "trace", PRXMPLS = "example", PRHELP = "?", QUIT = "quit";

	private static final String FREEVARS = "FV";  // ͳѿ̣뵭

	private static final String PREFIX = LExprHandler.PREFIX;

	// ƱƤǥեȤΥե̾
	// getResourceAsStream() ǥץǽʥե̾Ǥ뤳.
	private static final String PropFile = "/lambda.properties";
	private static final String MACRODEFS = "/definitions.txt";
	private static final String EXAMPLES = "/examples.txt";
	private static final String USAGE = "/usage.txt";
	private static final String HELPRSRC = "/help.txt";

	private static final String
		INFINITELOOP = "infinite loop(?)",
		INVALID = "invalid syntax",
		INVALCMD = "unknown command",
		INVALNUM = "invalid number",
		INVALARG = "invalid arg",
		OUTOFBOUNDS = "out of bounds",
		AMBIGUOUS = "ambiguous command",
		HELP = "<> ϲǽʤΤϥ, ޥ, ޥɤ"
			+ "줫. (" + cmdMark + PRHELP + " Ǿܺ)",
		STEPHELP = "<> ϲǽʤΤֹޤ q(λ) Ǥ"
			+ "ԤΤߤ 1 Ȳ᤹.",
		STEPINDENT = "    ",
		PROMPTMSG = "lambda> ",
		STEPMSG = "number or quit? ",
		STEPMSG2 = "ENTER or quit? ",
		STEPMSG3 = "stepwise or continuously? ";

	/**
	 * 󥹥ȥ饯
	 */
	public LambdaCalculus(Reader r, Writer w, String file, boolean verbose,
			boolean rverbose)
				throws IOException {

		endMark = System.getProperty(PREFIX + "endofexp", ";");
		if (endMark.length() <= 0)
			throw new IllegalStateException("end mark is empty");
		stepMark = System.getProperty(PREFIX + "endofexp2", "->");
		if (stepMark.length() <= 0)
			throw new IllegalStateException("step mark is empty");
		lmstepMark = System.getProperty(PREFIX + "endofexp3", "=>");
		if (lmstepMark.length() <= 0)
			throw new IllegalStateException("leftmost step mark is empty");
		macroDef = System.getProperty(PREFIX + "macrodef", "=");
		macroStart = System.getProperty(PREFIX + "macro1", "<");
		macroEnd = System.getProperty(PREFIX + "macro2", ">");

		this.verbose = verbose;
		Reader cr = new CommentRemover(r, blockComment1, blockComment2,
			lineComment, false);
		reader = new BufferedReader(cr);
		writer = new PrintWriter(w);
		try { prompt = !reader.ready(); } catch (IOException e) { /*ignore*/ }

		handler = createHandler(macroStart, macroEnd, rverbose ? writer : null);
		handler.defineMacros((file != null) ? load(file) : load());
	}

	/**
	 * LExprHandler֥Ȥ.
	 */
	private LExprHandler createHandler(String mstart, String mend,
			PrintWriter w) {
		String key = LExprHandler.class.getName() + ".class";
		String className = System.getProperty(key);
		if (className != null && className.length() > 0) {
			try {
				Class c = Class.forName(className);
				Constructor con = c.getConstructor(new Class[]{
					String.class, String.class, PrintWriter.class
				});
				return (LExprHandler)con.newInstance(new Object[]{
					mstart, mend, w
				});
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		throw new IllegalStateException("check env");
	}

	/**
	 * , ޥ, ޥɤϤƽ롼
	 */
	public void interpret() {
		if (prompt)
			printHelp();
		for ( ; ; ) {
			// ޥɤޤϥϤ.
			String s = null;
			String end = null;
			try {
				s = input(reader, PROMPTMSG, prompt);
				if (s == null || s.length() <= 0)
					break;  // EOF
				end = s.endsWith(endMark) ? endMark
					: (s.endsWith(stepMark) ? stepMark
					: (s.endsWith(lmstepMark) ? lmstepMark : ""));
				s = s.substring(0, s.length() - end.length());
			} catch (IOException e) {
				System.err.println("Error: " + e.getMessage());
				continue;
			} catch (UnsupportedOperationException e) {
				System.err.println(HELP);
				continue;
			}
			// Ϥ줿ޥɤޤϥ¹Ԥ.
			try {
				if (s.startsWith(cmdMark)) {
					// ޥɤμ¹
					if (!processCommand(s.substring(cmdMark.length()).trim()))
						break;
					continue;
				}
				if (s.indexOf('[') >= 0) {
					// 黻 (M[x:=N] ޤ [N/x]M)
					LExpr expr = handler.substitute(s);
					if (expr != null)
						handler.print(writer, expr, s, false);
					continue;
				}
				int pos = s.indexOf(macroDef);
				if (pos < 0) {
					// ɾ
					processExpression(s, end);
				} else {
					// ޥ
					String name = s.substring(0, pos).trim();
					String value = s.substring(pos + macroDef.length()).trim();
					handler.defineMacro(name, value);
				}
			} catch (EOFException e) {
				break;
			} catch (Exception e) {
				System.err.println("Error: " + e.getMessage());
				if (e.getMessage() == null)
					e.printStackTrace();
			}
		}
		try {
			writer.close();
			reader.close();
		} catch (IOException e) { }
		if (prompt)
			System.err.println();
	}

	/**
	 * Ϥ줿׻̤Ϥ.
	 *
	 * @param s Ϥ줿ʸ
	 * @param end endMarkʤ,
	 *            stepMarkʤУƥå״,
	 *            lmstepMarkʤкǺ.
	 */
	private void processExpression(String s, String end) throws IOException {
		LExpr expr = handler.createLExpr(s);
		if (expr == null)
			return;
		if (end.equals(endMark)) {
			// Ʒ̤Ϥ.
			ResultValue result = handler.normalize(expr, verbose);
			if (result != null) {
				if (!result.halted()) {
					writer.println(INFINITELOOP);
				} else {
					LExpr e = result.getValue();
					handler.print(writer, e, s, verbose);
				}
				if (prompt)
					writer.println(result.observedData());
			}
		} else if (end.equals(stepMark)) {
			// ٤ƤΣƥå״̤Ϥʤ򷫤֤.
			for ( ; ; ) {
				LExpr array[] = handler.step(expr);
				if (array.length <= 0)
					break;
				for (int n = 0; n < array.length; n++) {
					writer.print(STEPINDENT + "[" + (n+1) + "] ");
					handler.print(writer, array[n], s, false);
				}
				int index = inputIndex(reader, STEPMSG, array.length);
				if (index >= array.length)
					break;
				expr = array[index];
			}
		} else if (end.equals(lmstepMark)) {
			String resp = inputString(reader, STEPMSG3);
			boolean stepwise = resp.length() <= 0 || resp.charAt(0) != 'c';
			// ƥå׺Ǻ̤Ϥʤ򷫤֤.
			for ( ; ; ) {
				LExpr newexpr = handler.convert(expr);
				if (newexpr == null)
					break;
				writer.print(stepwise ? STEPINDENT : stepMark + " ");
				handler.print(writer, newexpr, s, false);
				if (stepwise) {      // Ϣ³ξäʤ.
					int index = inputIndex(reader, STEPMSG2, 1);
					if (index >= 1)
						break;       // Ǻ̤ϣ
				}
				expr = newexpr;
			}
		}
	}

	/**
	 * ޥɤ.
	 */
	private boolean processCommand(String s) throws IOException {
		int pos = s.indexOf(' ');
		if (pos < 0)
			pos = s.indexOf('\t');
		String cmd = s;
		String arg = "";
		if (pos >= 0) {
			cmd = s.substring(0, pos).trim();
			arg = s.substring(pos+1).trim();
		}
		switch (getCommandNumber(cmd)) {
		case 0:  // PRVAL
			printFreeVariables(arg);
			break;
		case 1:  // MAXSTEPS
			if (arg.length() > 0)
				handler.setMaxSteps(Integer.parseInt(arg));
			else
				writer.println(handler.getMaxSteps());
			break;
		case 2:  // ETACNV
			handler.suppressEtaConversion(!boolArg(arg));
			break;
		case 3:  // LOAD
			handler.defineMacros(load(arg));
			break;
		case 4:  // PRMACRO
			handler.printMacros(writer, "ѤߤΥޥ");
			break;
		case 5:  // FORMAT
			handler.setFormat(arg);
			break;
		case 6:  // RESHAPE
			handler.setReshape(boolArg(arg));
			break;
		case 7:  // TRACE
			setTrace(arg);
			break;
		case 8:  // PRXMPLS
			printExamples(arg);
			break;
		case 9:  // PRHELP
			printHelp();
			break;
		case 10: // QUIT
			return false;  // λ
		}
		return true;
	}

	/**
	 * FV(M) ηʸᤷƼͳѿν֤.
	 */
	private void printFreeVariables(String s) {
		if (s.length() <= 0)
			return;
		int p1 = s.indexOf('(');
		if (p1 >= 0) {
			int p2 = s.lastIndexOf(')');
			if (p2 >= 0) {
				String keywd = s.substring(0, p1).trim();
				if (keywd.equals(FREEVARS)) {
					String exprstr = s.substring(p1+1, p2).trim();
					LExpr expr = handler.createLExpr(exprstr);
					Set set = handler.freeVariables(expr);
					String val = set.toString();
					writer.println(val.replace('[', '{').replace(']', '}'));
					return;
				}
			}
		}
		throw new IllegalArgumentException(INVALID + arg(s));
	}

	/**
	 * ͰʸͤѴ.
	 */
	private boolean boolArg(String s) {
		if (s.length() <= 0)
			return true;
		if (!"off".startsWith(s))
			throw new IllegalArgumentException(INVALARG + arg(s));
		return false;
	}

	/**
	 * ޥʸåͤѴ.
	 */
	private int getCommandNumber(String s) {
		List list = new ArrayList();
		int index = -1;
		for (int n = 0; n < CmdArgs.length; n++)
			if (CmdArgs[n][0].startsWith(s))
				list.add(CmdArgs[index = n][0]);
		if (list.size() == 1)
			return index;
		if (list.size() >= 2)
			throw new IllegalArgumentException(AMBIGUOUS + arg(s));
		throw new IllegalArgumentException(INVALCMD + arg(s));
	}

	private static final String
		PRVAL_ARG = FREEVARS + "(expr)",
		PRVAL_DESC = "μͳѿ [] " + cmdMark + PRVAL
			+ " " + FREEVARS + "(\\x.abx)",
		MAXSTEPS_DESC = "ͤꡦ [1]",
		ETACNV_DESC = "Ѵ (x.MxM)",
		LOAD_DESC = "ޥ",
		PRMACRO_DESC = "Ѥߥޥɽ",
		FORMAT_DESC = "νϷ [2]",
		RESHAPE_DESC = "νϤޥ̾˽",
		TRACE_DESC = "ȥ졼ɽ (offꤹȥȥ졼)",
		PRXMPLS_DESC = "Ȥ (ꤹȥեؽ)",
		PRHELP_DESC = "إɽ",
		QUIT_DESC = "λ";

	private static final String CmdArgs[][] = {
		{ PRVAL,    PRVAL_ARG,   PRVAL_DESC },
		{ MAXSTEPS, "[number]",  MAXSTEPS_DESC },
		{ ETACNV,   "[off]",     ETACNV_DESC },
		{ LOAD,     "macrofile", LOAD_DESC },
		{ PRMACRO,  "",          PRMACRO_DESC },
		{ FORMAT,   "arg",       FORMAT_DESC },
		{ RESHAPE,  "[off]",     RESHAPE_DESC },
		{ TRACE,    "[off]",     TRACE_DESC },
		{ PRXMPLS,  "[file]",    PRXMPLS_DESC },
		{ PRHELP,   "",          PRHELP_DESC },
		{ QUIT,     "",          QUIT_DESC },
	};

	private static final String CmdList;

	/**
	 * 饹ǥ󥰻ʸ CmdList .
	 */
	static {
		String eol = System.getProperty("line.separator");
		int max = 0;
		for (int n = 0; n < CmdArgs.length; n++) {
			int len = CmdArgs[n][0].length() + CmdArgs[n][1].length();
			if (max < len)
				max = len;
		}
		StringBuffer csb = new StringBuffer();
		for (int n = 0; n < CmdArgs.length; n++) {
			csb.append("    ").append(cmdMark).append(CmdArgs[n][0]);
			csb.append(" ").append(CmdArgs[n][1]).append(" ");
			for (int i = max - CmdArgs[n][0].length() - CmdArgs[n][1].length();
					i > 0; i--)
				csb.append(" ");
			csb.append(CmdArgs[n][2]);
			if (n < CmdArgs.length-1)
				csb.append(eol);
		}
		CmdList = csb.toString();
	}

	private String fmtArgList;  // cache

	/**
	 * إץåϤ.
	 */
	private void printHelp() {
		if (fmtArgList == null)
			fmtArgList = handler.getFormatCaption("             ");
		try {
			copy(System.err, HELPRSRC, new Object[] {
				endMark, stepMark, lmstepMark, macroDef, macroStart, macroEnd,
				CmdList, fmtArgList,
			});
		} catch (IOException e) {
		}
	}

	/**
	 * Ȥ򼨤Ϥ.
	 */
	private void printExamples(String outfile) throws IOException {
		PrintWriter out = this.writer;
		try {
			if (outfile.length() > 0)
				out = new PrintWriter(new FileWriter(outfile));
			copy(out, EXAMPLES, null);
			out.println();
			out.flush();
		} finally {
			if (outfile.length() > 0)
				out.close();
		}
	}

	/**
	 * ȥ졼ѤWriter椹.
	 */
	private void setTrace(String s) {
		if (s.length() <= 0) {
			verbose = true;
		} else {
			if (!"off".startsWith(s))
				throw new IllegalArgumentException(INVALARG + arg(s));
			verbose = false;
		}
	}

	/**
	 * ƱƤ꥽Υޥɤ߹.
	 */
	private Map load() throws IOException {
		StringWriter sw = new StringWriter();
		PrintWriter out = new PrintWriter(sw);
		copy(out, MACRODEFS, null);
		out.flush();
		return load(new StringReader(sw.toString()));
	}

	/**
	 * ꤵ줿եΥޥɤ߹.
	 */
	private Map load(String file) throws IOException {
		return load(new FileReader(file));
	}

	/**
	 * ꤵ줿Readerޥɤ߹.
	 */
	private Map load(Reader in) throws IOException {
		Map map = new LinkedHashMap();
		Reader rdr = new CommentRemover(in, blockComment1, blockComment2,
			lineComment, false);
		BufferedReader r = new BufferedReader(rdr);
		try {
			for ( ; ; ) {
				String s = input(r, null, false);
				if (s == null)
					break;
				int pos = s.indexOf(macroDef);
				if (pos >= 0 && s.endsWith(endMark)) {
					s = s.substring(0, s.length() - endMark.length());
					String name = s.substring(0, pos).trim();
					String value = s.substring(pos + macroDef.length()).trim();
					map.put(name, value);
				}
			}
		} finally {
			r.close();
		}
		return map;
	}

	/**
	 * JARեƱƤ꥽PrintWriterؽϤ.
	 */
	private static void copy(PrintWriter out, String name, Object args[])
			throws IOException {
		BufferedReader in = new BufferedReader(new ResourceReader(name, args));
		for (String s = null; (s = in.readLine()) != null; )
			out.println(s);
		out.flush();
	}

	/**
	 * JARեƱƤ꥽PrintStreamؽϤ.
	 */
	private static void copy(PrintStream out, String name, Object args[])
			throws IOException {
		BufferedReader in = new BufferedReader(new ResourceReader(name, args));
		for (String s = null; (s = in.readLine()) != null; )
			out.println(s);
		out.flush();
	}

	private String arg(String s) { return ": \"" + s + "\""; }

	/*-------------------------------------------------------------------*/

	/**
	 * ޥɤޤϥϤʸ֤.
	 * Υ᥽åɤ
	 *   EOFξ
	 *   ޥɤǤĲԤϤ줿
	 *   μλΤ줫Ϥ줿
	 * EOFξ null ֤Ȥ.
	 */
	private String input(BufferedReader in, String msg, boolean prompt)
			throws IOException {
		if (prompt)
			writer.flush();
		if (prompt && msg != null && msg.length() > 0)
			System.err.print(msg);
		StringBuffer sb = new StringBuffer();
		for ( ; ; ) {
			int c = in.read();
			if (c < 0) {
				if (sb.length() <= 0)
					return null;  // EOF
				break;
			}
			if (c == '\n') {  // Mac̵
				String s = sb.toString().trim();
				if (s.length() > 0 && s.startsWith(cmdMark))
					break;
				if (s.length() > 0 && s.charAt(0) == '?')
					throw new UnsupportedOperationException();  // help
			}
			sb.append((char)c);
			if (c == endMark.charAt(0) || c == stepMark.charAt(0)
					|| c == lmstepMark.charAt(0)) {
				while ((c = in.read()) >= 0) {
					if (c == ' ' || c == '\t' || c == '\n')
						break;
					sb.append((char)c);
				}
				String s = sb.toString().trim();
				if (s.endsWith(endMark) || s.endsWith(stepMark)
						|| s.endsWith(lmstepMark))
					break;
			}
		}
		if (prompt)
			while (in.ready())
				if (in.read() < 0)
					break;
		return sb.toString().trim();
	}

	/**
	 * ƥå״ֹ̤򤹤.
	 * EOFξ EOFException 򥹥뤳Ȥ.
	 */
	private int inputIndex(BufferedReader in, String msg, int max)
			throws IOException {
		if (prompt)
			writer.flush();
		for ( ; ; ) {
			String ns = null;
			try {
				if (prompt && msg != null && msg.length() > 0)
					System.err.print(STEPINDENT + msg);
				ns = in.readLine();
			} catch (IOException e) { /*ignore*/ }
			if (ns == null)
				throw new EOFException();     // EOF
			ns = ns.trim();
			if (ns.length() > 0 && ns.charAt(0) == 'q')
				break;
			try {
				int index = (ns.length() <= 0) ? 0 : Integer.parseInt(ns)-1;
				if (0 <= index && index < max)
					return index;
				System.err.println(STEPINDENT + "Error: " + OUTOFBOUNDS);
			} catch (NumberFormatException e) {
				System.err.println(STEPINDENT + "Error: " + INVALNUM);
				System.err.println(STEPINDENT + STEPHELP);
			} catch (Exception e) {
				System.err.println(STEPINDENT + "Error: " + e.toString());
				break;
			}
		}
		return Integer.MAX_VALUE;  // Ϥ.
	}

	/**
	 * ʸϤ.
	 * EOFξ EOFException 򥹥뤳Ȥ.
	 */
	private String inputString(BufferedReader in, String msg)
			throws IOException {
		if (prompt)
			writer.flush();
		if (prompt && msg != null && msg.length() > 0)
			System.err.print(msg);
		String s = null;
		try {
			s = in.readLine();
		} catch (IOException e) { /*ignore*/ }
		if (s == null)
			throw new EOFException();    // EOF
		return s.trim();
	}

	/*-------------------------------------------------------------------*/

	/**
	 * ׻ץ
	 */
	public static void main(String argv[]) throws IOException {
		String infile = null;
		String outfile = null;
		String macrofile = null;
		String userpropfile = null;
		String newpropfile = null;
		String newmacrofile = null;
		boolean everbose = false;
		boolean rverbose = false;

		for (int n = 0; n < argv.length; n++) {
			String s = argv[n];
			if (s.length() < 2 || s.charAt(0) != '-')
				error();
			if (s.equals("-v")) {
				everbose = true;
				continue;
			}
			if (s.equals("-V")) {    // 
				rverbose = true;
				continue;
			}
			String val = s.substring(2);
			if (val.length() <= 0) {
				if (n+1 >= argv.length)
					error();
				val = argv[++n];
			}
			switch (s.charAt(1)) {
			case 'p': userpropfile = val; break;
			case 'c': newpropfile = val; break;
			case 'i': infile = val; break;
			case 'o': outfile = val; break;
			case 'l': macrofile = val; break;
			case 'm': newmacrofile = val; break;
			default:  error();
			}
		}

		if (newpropfile != null || newmacrofile != null) {
			if (newpropfile != null)
				initPropFile(newpropfile);
			if (newmacrofile != null)
				createMacroFile(newmacrofile);
		} else {
			Reader r = (infile != null)
				? (Reader)new FileReader(infile)
				: (Reader)new InputStreamReader(System.in);
			Writer w = (outfile != null)
				? (Writer)new FileWriter(outfile)
				: (Writer)new OutputStreamWriter(System.out);
			prepare(userpropfile);
			LambdaCalculus lambda =
				new LambdaCalculus(r, w, macrofile, everbose, rverbose);
			lambda.interpret();
		}
	}

	/**
	 * ץѥƥμȥƥץѥƥؤΥԡ
	 */
	private static void prepare(String file) throws IOException {
		Properties p = (new PropertiesHandler()).getProperties(PropFile, file);
		// ץѥƥ򥷥ƥץѥƥ˥ԡ.
		for (Enumeration e = p.propertyNames(); e.hasMoreElements(); ) {
			String key = (String)e.nextElement();
			System.setProperty(key, p.getProperty(key));
		}
	}

	/**
	 * 桼ץѥƥեθ
	 * @param file ե̾
	 */
	private static void initPropFile(String file) throws IOException {
		String PropComment[] = {
			"׻Υץѥƥ",
			"",
			"ޥˡ",
			"  ץѥƥ name = value ηǻꤵ. "
				+ "ʳϥȤǤ.",
			"  ޥϥȵ(#)"
				+ "ץѥƥͤѹ.",
		};
		(new PropertiesHandler()).createFile(PropFile, file, PropComment);
		System.err.println("[] " + file + " ޤ.");
		System.err.println("  ѹץѥƥΥȤ"
			+ "ŬԽƤ.");
		System.err.println("  Υե̾ꤹ륪ץ -p Ǥ.");
	}

	/**
	 * 桼ޥեθ
	 * @param file ե̾
	 */
	private static void createMacroFile(String file) throws IOException {
		PrintWriter out = new PrintWriter(new FileWriter(file));
		try {
			copy(out, MACRODEFS, null);
			System.err.println("[] " + file + " ޤ.");
			System.err.println("  Υե̾ꤹ륪ץ"
				+ " -l Ǥ.");
			System.err.println("  ¹˥ޥ :load ɤ߹ळȤ"
				+ "Ǥޤ.");
		} catch (IOException e) {
		} finally {
			out.close();
		}
	}

	/**
	 * ưˡϤƥץλ.
	 */
	private static void error() {
		String name = LambdaCalculus.class.getName();
		try {
			copy(System.err, USAGE, new Object[]{ name });
		} catch (IOException e) {
		}
		System.exit(1);
	}
}
