package mypkg.lambda;

/**
 * -redex̍\vf
 *
 * (x.M)N ̌`̃_ -redex ƌĂ. ̃NX͂ -redex
 * ̍\vf\.
 * ̃NX̃IuWFNg̓c[̃m[hƂȂ邱Ƃ͑z肵ĂȂ.
 * c[̃m[hƂȂNX Variable, Abstraction, Application ł.
 * ̃NX -redex ̑ZƂ̌ʂ̃g[X𐳂o͂
 * ړÎ߂ɗp.
 * Ƃ
 *     z(z$07)[$07:=$01]
 * ̂悤ȃg[Xo͂̕ϐu(LExpr.reshape())ꍇ
 *     ($07.z(z$07))$01
 * ɕϊ LExpr.reshape() s
 *     (y.z(zy))x
 * ƂȂ. ̃_玟̌ʂ𓾂.
 *     (z(zy))[y:=x]
 * ܂肱̃NX -redex ̊֐{, , ܂Ƃ߂ċL
 * .
 */
public class BetaRedex extends LExpr {

	private LExpr body;       // M -- (x.M)N
	private String param;     // x -- (x.M)N
	private LExpr arg;        // N -- (x.M)N

	/**
	 * RXgN^
	 */
	public BetaRedex(LExpr body, String param, LExpr arg) {
		this.body = body;
		this.param = param;
		this.arg = arg;
	}

	/**
	 * ̃IuWFNg̃Rs[Ԃ.
	 */
	public Object clone() {
		BetaRedex newexpr = null;
		try {
			newexpr = (BetaRedex)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.body = (LExpr)this.body.clone();
		newexpr.param = this.param;
		newexpr.arg = (LExpr)this.arg.clone();
		return newexpr;
	}

	/**
	 * ֐{̂̃_Ԃ.
	 */
	public LExpr getBodyOfRedex() { return body; }

	/**
	 * Ԃ.
	 */
	public String getParamOfRedex() { return param; }

	/**
	 * ̃_Ԃ.
	 */
	public LExpr getArgOfRedex() { return arg; }

	/**
	 * I[oCh
	 * ϊŕtꂽϐu鎞, ֐{, , 
	 * u𓯎ɍsKv. , ł͈U_
	 * gݗĂăX[pNX reshape() s, ̓e -redex
	 * 쐬.
	 */
	public LExpr reshape() {
		LExpr abs = LExpr.getInstance(param, body);  // x.M
		LExpr app = LExpr.getInstance(abs, arg);     // (x.M)N
		LExpr newapp = app.reshape();
		LExpr newabs = newapp.getFunction();
		return LExpr.getInstance(
			newabs.getBody(), newabs.parameterName(), newapp.getArgument()
		);
	}

	/**
	 * łȌȐwI\̕Ԃ.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		String bs = body.toAbbrevString(uselambda);
		String as = arg.toAbbrevString(uselambda);
		return substString(bs, param, as);
	}

	/**
	 * ȌȐwI\̕Ԃ.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		String bs = body.toMathString(uselambda);
		String as = arg.toMathString(uselambda);
		return substString(bs, param, as);
	}

	/**
	 * 璷ȐwI\̕Ԃ.
	 *  (x.(y.(z.((xy)z))))[x:=N]
	 */
	protected String toProperString(boolean uselambda) {
		String bs = body.toProperString(uselambda);
		String as = arg.toProperString(uselambda);
		return substString(bs, param, as);
	}

	private String substString(String bs, String param, String as) {
		StringBuffer sb = new StringBuffer(parenthesize(bs));
		sb.append("[").append(param).append(":=").append(as).append("]");
		return sb.toString();
	}
}
