package mypkg.lambda;

import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeSet;
import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;
import java.lang.reflect.Constructor;

/**
 * _
 *
 * _Ƃ
 *     ϐ | _ | ֐Kp
 * ł, ̃NX͂ʂɎ舵߂̒ۃNXł.
 *
 *     _    TuNX         ͗
 *   ----------------------------------------------
 *     ϐ        Variable             x
 *     _  Abstraction  x.M ܂ \x.M
 *     ֐Kp    Application          MN
 *
 * ̃NX̃TuNẌӖ, _c[ŕ\ꍇ̃m[h
 * Ήf[^ł.
 *
 * Oɒ񋟂C^tF[X@\ɂ
 *     ōȖ, , Rϐ̒T, ľ, ̑
 * .
 * TuNX (ϐE_ہE֐Kp) ׂ@\, L̃C^
 * tF[X@\̃TuNXŗL̏ł.
 * ̃NX͎ɗp҂ւpublicC^[tF[XƃTuNXւprotected
 * C^[tF[X񋟂邪, TuNX̂߂̎኱̎܂.
 *
 * _vZ̗.
 *
 *     // ̃_
 *     String s = in.readLine();
 *
 *     // LExprFactory gĕ񂩂烉_֕ϊ
 *     // factory IuWFNg̍쐬ɂĂ͏Kvł邪
 *     // ׂƂCɂȂ
 *     //     LExprFactory factory = new MathLExprFactory(null, null);
 *     // ƂĂ悢. ʂ̃C^tF[X LExprHandler g
 *     // ̃NX̏ڍׂCɂɃ_vZsł.
 *     LExpr expr = factory.create(s);
 *
 *     // PXebv̍ōȖsꍇ
 *     LExpr value = expr.reduce();
 *     System.out.println(value);
 *
 *     // PXebvׂ̂Ă̊Ȗ񌋉ʂ߂ꍇ
 *     LExpr array[] = expr.reduceAll();
 *     for (int n = 0; n < array.length; n++)
 *         System.out.println("[" + (n+1) + "] " + array[n]);
 *
 * VXevpeB
 * ~~~~~~~~~~~~~~~~~~
 * EftHg̏o͌` lambdacalc.format
 *     Ȗ񌋉ʂ̃_ǂ̕\`ŏo͂邩w肷.
 *       \Ȓl
 *           abbrev: łȌȐwI\ [] xy.xyz
 *           math:   ȌȒʏ̐wI\ [] x.y.xyz
 *           proper: f[^\𖾊mwI\ [] x.(y.((xy)z))
 *       ftHgl: abbrev
 *      [l] proper͊ʂ𑽗pf[^\𖾊m邪math͂ł邾
 *             ʂȗ\ł. abbrev͑ϐ֐̕\
 *             ɂ.
 */
public abstract class LExpr implements Cloneable {

    // ------------------------------------------------------------------
    // ̃NXXbhZ[tłKv͂ȂƎv邪, Kv
    // Ȃꍇ serialno Ȃǂ̕ϐɑ΍􂪕Kvł.
    // ------------------------------------------------------------------

	/*-------------------------------------------------------------------*/
	// JC^tF[X

	/**
	 * _̂PXebvōȖ񏈗 -- ϊ
	 *
	 * @return PXebvōȖ񌋉ʂ̃_
	 */
	public LExpr reduce() {
		return reduce(0);
	}

	/**
	 * _̂PXebvȖ񏈗 -- ϊ
	 * ̃\bh͍ōȖ񂾂ł͂ȂׂĂ̊Ȗ񌋉ʂԂ.
	 *
	 * @return  PXebvȖ񌋉ʂ̔z (vf̌^LExpr)
	 */
	public LExpr[] reduceAll() {
		List list = reduceAll(0);
		return (LExpr[])list.toArray(new LExpr[list.size()]);
	}

	/**
	 *  M[x:=N]
	 * ̃_(M)̉(param)Ɏ(arg).
	 *
	 * @param param ɑϐ (x)
	 * @param arg   ɑ郉_ (N)
	 * @return  Zʂ̒l
	 */
	public LExpr substitute(String param, LExpr arg) {
		return substitute(param, arg, 0);
	}

	/**
	 * Rϐ̏WԂ.
	 *
	 * @return ̃IuWFNg̎Rϐ̏W
	 */
	public Set freeVariables() {
		Set set = new TreeSet();
		this.gatherFreeVars(set);
		return set;
	}

	/**
	 * ̃IuWFNgw̃_ƃlȂtrueԂ.
	 *
	 * @param expr rΏۂ̃_
	 * @return lȂtrue
	 */
	public boolean isAlphaEquivalent(LExpr expr) {
		return this.isEquivalent(expr, new LinkedList(), 0);
	}

	/**
	 * Iȃϊō쐬ꂽϐKȕϐɒu.
	 * ϊƂ͑ϐ̕tłx.xxy.yyɕϊ邱Ƃ
	 * Ӗ.
	 *  $08.$10.$10 -> x.y.y
	 *
	 * @return Kȕϐɒuꂽ_
	 */
	public LExpr reshape() {
		return reshapeThis();
	}

	/**
	 * ̃IuWFNg̎w`̕\Ԃ.
	 *
	 * @param format o͌`̎ʖ
	 * @param uselambda _ \ ł͂Ȃ LExpr.LAMBDA gp
	 * @return \
	 */
	public String getString(String format, boolean uselambda) {
		if (ABBREVFORMAT.equals(format))
			return simplify(toAbbrevString(uselambda));
		if (MATHFORMAT.equals(format))
			return toMathString(uselambda);
		if (PROPERFORMAT.equals(format))
			return toProperString(uselambda);
		throw new IllegalArgumentException("unknown format: " + format);
	}

	/**
	 * ̃IuWFNg̕\Ԃ.
	 *
	 * @return \
	 */
	public String toString() {
		String fmt = System.getProperty(DEFFORMATKEY, ABBREVFORMAT);
		return getString(fmt, false);
	}

	/**
	 * ϐ\_IuWFNg쐬.
	 * VXevpeB mypkg.lambda.LExpr.var.class w肳Ă
	 * ̒lNXƉ肵, w肪Ȃ mypkg.lambda.Variable 
	 * NXƂ.
	 *
	 * @param name ϐ
	 * @return ϐ\_
	 */
	public static LExpr getInstance(String name) {
		return createObject(VAR_ID,
			new Class[]{ String.class },
			new Object[]{ name }
		);
	}

	/**
	 * _ۂ\_IuWFNg쐬.
	 * VXevpeB mypkg.lambda.LExpr.abs.class w肳Ă
	 * ̒lNXƉ肵, w肪Ȃ mypkg.lambda.Abstraction
	 * NXƂ.
	 *
	 * @param parameter 
	 * @param body ֐{
	 * @return _ۂ\_
	 */
	public static LExpr getInstance(String parameter, LExpr body) {
		return createObject(ABS_ID,
			new Class[]{ String.class, LExpr.class },
			new Object[]{ parameter, body }
		);
	}

	/**
	 * ֐Kp\_IuWFNg쐬.
	 * VXevpeB mypkg.lambda.LExpr.app.class w肳Ă
	 * ̒lNXƉ肵, w肪Ȃ mypkg.lambda.Application
	 * NXƂ.
	 *
	 * @param func ֐
	 * @param arg 
	 * @return ֐Kp\_
	 */
	public static LExpr getInstance(LExpr func, LExpr arg) {
		return createObject(APP_ID,
			new Class[]{ LExpr.class, LExpr.class },
			new Object[]{ func, arg }
		);
	}

	/**
	 * -redex\_IuWFNg쐬.
	 * VXevpeB mypkg.lambda.LExpr.redex.class w肳Ă
	 * ̒lNXƉ肵, w肪Ȃ mypkg.lambda.BetaRedex N
	 * XƂ.
	 * ԂIuWFNg LExpr^ł͂邪ϐ, _, ֐Kp
	 * 悤Ƀc[̃m[hƂȂ邱Ƃ͑z肵ĂȂ.
	 *
	 * @param body ֐{
	 * @param param 
	 * @param arg 
	 * @return -redex\_
	 */
	public static LExpr getInstance(LExpr body, String param, LExpr arg) {
		return createObject(REDEX_ID,
			new Class[]{ LExpr.class, String.class, LExpr.class },
			new Object[]{ body, param, arg }
		);
	}

	/**
	 * ̃IuWFNg̃Rs[.
	 *
	 * @return ̃IuWFNg̃Rs[
	 */
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			// assert false;
			throw new IllegalStateException();
		}
	}

	/**
	 * C[^()ϊ}邩ǂ𐧌䂷.
	 *
	 * @param value true Ȃ΃ŕϊ}
	 */
	public static void suppressEtaConversion(boolean value) {
		noEtaConversion = value;
	}

	/*-------------------------------------------------------------------*/
	// TuNXŃI[oCh܂ׂ͎@\

	/**
	 * _̂PXebvōȖ񏈗 -- ϊ
	 * ̃\bh͍ōȖ񂳂ꂽ_PԂ.
	 *
	 * ϊ̒` (vZ_ q p.65)
	 * L̓ϊӖ̂Ƃ.
	 *
	 *        K                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N Ȃ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N Ȃ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N Ȃ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * Ƃ΂̃IuWFNg(this)
	 *     ((a.b)c)((x.y)z)
	 * Ƃ
	 *     b((x.y)z)
	 * Ԃ.
	 *
	 * @param level ċAďox
	 * @return  PXebvōȖ񌋉ʂ̃_ (łɐK`Ȃnull)
	 */
	protected LExpr reduce(int level) {
		return null;
	}

	/**
	 * _̂PXebvȖ񏈗 -- ϊ
	 * ̃\bh͍ōȖ񂾂ł͂ȂׂĂ̊Ȗ񌋉ʂԂ.
	 *
	 * ϊ̒` (vZ_ q p.65)
	 * L̓ϊӖ̂Ƃ.
	 *
	 *        K                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N Ȃ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N Ȃ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N Ȃ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * PXebvȖ̌ʂ͕蓾̂, ̃\bhList<LExpr>^
	 * ̒lԂ. Ƃ΂̃IuWFNg(this)
	 *     ((a.b)c)((x.y)z)
	 * Ƃ
	 *     [b((x.y)z); ((a.b)c)y]
	 * Ԃ.
	 *
	 * Ȗ񌋉ʂꍇ͍ōȖ񂪐擪vfƂȂASYƂȂ
	 * . ĐK`߂邽߂ɂ̃\bhĂяoꍇ͍ō
	 * Ȗ񂾂擾ΖʂȌvZȗł.
	 * ׂĂ̊Ȗ񌋉ʂ߂@\, mF, Ȗ@ɂ
	 * ͒~ȂƂȂǂmF邽߂ɗpӂĂ.
	 *
	 * @param level ċAďox
	 * @return  PXebvȖ񌋉ʂ̃Xg
	 */
	protected List reduceAll(int level) {
		// ̃\bȟ^ LExpr[] łׂJԂĂяo
		// \l List Ƃ. Y-Combinator gvZł͊ȒP
		// ̌JԂ.
		return null;
	}

	/**
	 * _̂PXebvȖ񏈗 -- -redex̏ꍇ
	 * -redexƂ(x.M)Ň`̃_Ӗ.
	 * ̃\bh͑Ώۂ x.M ł arg  N ƂČĂяo.
	 * TuNX̃_ۂ݂̂ null ł͂ȂlԂ.
	 */
	protected LExpr reduceRedex(LExpr arg, int level) {
		//########## (A) (x.M)N  M[x:=N] ##########
		return null;
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N l M 
	 *     ϐ, _, ֐Kp
	 * ̏ꍇɕċ߂.
	 * ̒` (vO~O̊b_ x~ p.18)
	 *
	 *        `                           
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  LȊO            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N ̎Rϐł͂ȂƂӖ.
	 *  [2] IɃϊ邱Ƃɒ. ϐ z ͂܂VO
	 *        I΂.
	 *
	 * @param param ɑϐ (x)
	 * @param arg   ɑ郉_ (N)
	 * @param level ċAďox
	 * @return  Zʂ̒l
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		return null;
	}

	/**
	 * ̃IuWFNg̃IuWFNgƃlȂtrueԂ.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		return false;
	}

	/**
	 * RϐW߂.
	 * Rϐ̒` (vO~O̊b_ x~ p.17)
	 *     FV(x) = {x}
	 *     FV(x.M) = FV(M) - {x}
	 *     FV(MN) = FV(M) OR FV(N)
	 */
	protected void gatherFreeVars(Set set) { }

	/**
	 * RϐϐʂׂĂ̕ϐW߂.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void gatherVars(Set set) { }

	/**
	 * Ή\QƂĕϐu.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void replaceVars(Map map) { }

	/**
	 * ̃IuWFNgϐȂ΂̖OԂ.
	 * ̏LExpr^̕ϐexprϐł邱Ƃ\.
	 *     expr.variableName() != null
	 */
	protected String variableName() { return null; }

	/**
	 * ̃IuWFNg_ x.M Ȃ΂̉ x Ԃ.
	 * ̏LExpr^̕ϐexpr_ۂł邱Ƃ\.
	 *     expr.parameterName() != null
	 */
	protected String parameterName() { return null; }

	/**
	 * ̃IuWFNg_ x.M Ȃ΂̊֐{ M Ԃ.
	 * ̏LExpr^̕ϐexpr_ۂł邱Ƃ\.
	 *     expr.getBody() != null
	 */
	protected LExpr getBody() { return null; }

	/**
	 * ̃IuWFNg֐Kp MN Ȃ΂̊֐ M Ԃ.
	 * ̏LExpr^̕ϐexpr֐Kpł邱Ƃ\.
	 *     expr.getFunction() != null
	 */
	protected LExpr getFunction() { return null; }

	/**
	 * ̃IuWFNg֐Kp MN Ȃ΂̈ N Ԃ.
	 * ̏LExpr^̕ϐexpr֐Kpł邱Ƃ\.
	 *     expr.getArgument() != null
	 */
	protected LExpr getArgument() { return null; }

	/**
	 * -redex (x.M)N ̊֐{(M)Ԃ.
	 */
	protected LExpr getBodyOfRedex() { return null; }

	/**
	 * -redex (x.M)N ̉(x)Ԃ.
	 */
	protected String getParamOfRedex() { return null; }

	/**
	 * -redex (x.M)N ̎(N)Ԃ.
	 */
	protected LExpr getArgOfRedex() { return null; }

	/**
	 * ̃IuWFNgChurchȂΐlԂ.
	 * łȂ IllegalStateException X[.
	 * ChurchƂ sz.s(s(EEE(sz)EEE)) ̌`̃_w.
	 */
	protected int getChurchNumeral(String succ, String zero) {
		throw new IllegalStateException();
	}

	/**
	 * łȌȐwI\̕Ԃ.
	 *  xyz.xyz
	 */
	protected abstract String toAbbrevString(boolean uselambda);

	/**
	 * ȌȐwI\̕Ԃ.
	 *  x.y.z.xyz
	 */
	protected abstract String toMathString(boolean uselambda);

	/**
	 * 璷ȐwI\̕Ԃ.
	 *  x.(y.(z.((xy)z)))
	 */
	protected abstract String toProperString(boolean uselambda);

	// true Ȃ΃ŕϊ}.
	protected static boolean noEtaConversion;

	/**
	 * ŕϊ
	 *     (x.Mx)N = MN  x ! FV(M)
	 * ł邱Ƃl
	 *     x.Mx = M
	 * ɒu\ł.
	 *
	 * ϐ null Ԃ.
	 * _ۂ͖{̂֐KpłApplicationɈϏłȂ
	 * null Ԃ.
	 * ֐Kp͉E̎w̖O̕ϐł邱ƂmF̎̎R
	 * ϐłȂƂmFč̎Ԃ.
	 */
	protected LExpr etaConversion(String param) {
		return null;
	}

	/*-------------------------------------------------------------------*/
	// 萔

	/**
	 * _̐wI\ɂ郉_ۂ\L
	 * []
	 *    ̋L͎͂̍ۂɂPł邱Ƃ肷. 
	 *    Sp̃_p̃obNXbVɌŒ肷ׂł.
	 */
	public static final String LAMBDA = "";

	/**
	 * vpeB̃vtBNX
	 */
	public static final String PREFIX = "lambdacalc.";

	// _̏o͌`֘A̒萔

	/** _̏o͌`w肷vpeB */
	public static final String DEFFORMATKEY = PREFIX + "format";
	/** _̏o͌`łȌȐwI\ƂvpeBl */
	public static final String ABBREVFORMAT = "abbrev";
	/** _̏o͌`ȌȒʏ̐wI\ƂvpeBl */
	public static final String MATHFORMAT = "math";
	/** _̏o͌`璷ȐwI\ƂvpeBl */
	public static final String PROPERFORMAT = "proper";

	/*-------------------------------------------------------------------*/
	// ϐ

	/**
	 * VAԍtăj[Nȕϐ邽߂̃vtBNX
	 * [l]
	 *    Ȗr̕ϐՓ˂hߕKvɉđϐ̃ϊs.
	 *    ͂̕̕ϐ̃vtBNXƂėp.
	 */
	private static final String VARPREFIX = "$";

    // j[Nȕϐ邽߂̃VAԍ
    private static int serialno;

	/**
	 * j[Nȕϐ쐬@\̏
	 * ŃϊsɃj[Nȕϐo@\KvɂȂ.
	 * ̃\bhĂяoł̋@\. ČvZ鎮
	 * ̕ύX鎞œKȌĂяõ^C~OƂȂ.
	 * ĂяoȂꍇ̕Q͒Og邾ŌvZɖ
	 * N킯ł͂Ȃ.
	 */
	protected static void init() { serialno = 0; }

	/**
	 * Iȃϊ̂߂̕ϐIuWFNg쐬.
	 */
	protected static LExpr uniqueVariable() {
		String ns = String.valueOf(++serialno);
		// 쐬̃\[g҂Ĕԍ2ȏƂ. 3ȏ͒߂.
		// 3ȏƂȂꍇ̉e͕ϐ̊蓖Ăς邱Ƃł
		// ʂ͈ˑRƂĐ.
		if (ns.length() == 1)
			ns = "0" + ns;
		return createObject(VAR_ID,
			new Class[]{ String.class },
			new Object[]{ VARPREFIX + ns }
		);
	}

	/**
	 * ϐ̂PڂƂĉ\ȕȂtrueԂ.
	 * ݂̕ϐ̎dl
	 *     [a-zA-Z][0-9]*
	 * ł. ̎dl͂̃NX̃TuNXƓ̓NX͕̎Ƃ
	 * LȂ΂ȂȂ.
	 * ̎dlɂ
	 *     e1e2
	 * ϐe1e2̘AƂ݂ȂwI\\ɂȂ.
	 *
	 * @param c 肷P
	 * @return  ϐ̂PڂƂĉ\Ȃtrue
	 */
	protected static boolean isVariableStart(int c) {
		return isVarStart(c);
	}

	/**
	 * ϐ̌`trueԂ.
	 * ̃NX̃TuNXŃIuWFNg쐬̃`FbN@\ƂĎg.
	 *
	 * @param name ϐ
	 * @return ϐ̌`true
	 */
	protected final boolean checkVariable(String name) {
		if (name == null || name.length() <= 0)
			return false;
		int off = 0;
		if (name.startsWith(VARPREFIX))
			off = VARPREFIX.length();
		else if (isVarStart(name.charAt(0)))
			off = 1;
		else
			return false;
		for ( ; off < name.length(); off++)
			if (!Character.isDigit(name.charAt(off)))
				return false;
		return true;
	}

	/**
	 * ϐ̂PڂƂĉ\ȕȂtrueԂ.
	 * ݂̎dl͉p܂͉p啶̂ꂩł. ̌ɐ
	 * Ƃ.
	 */
	private static boolean isVarStart(int c) {
		// Character.isLowerCase(), Character.isUpperCase() gȂ.
		// [] Character.isLowerCase((char)'') == true
		return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z';
	}

	// ̕т͕ϐƂĂӂ킵ƂȂĂ.
	private static final String Vchars =
		"xyzuvwpqrstabcdefghijklmno" + "XYZUVWPQRSTABCDEFGHIJKLMNO";
	private static final int Vcount = Vchars.length();

	/**
	 * Iȃϊō쐬ꂽϐKȕϐɒu.
	 *  $08.$10.$10 -> x.y.y
	 */
	private LExpr reshapeThis() {
		// gĂϐsetɏW߂.
		Set set = new TreeSet();
		this.gatherVars(set);
		int vcount = 0;
		for (Iterator i = set.iterator(); i.hasNext(); )
			if (((String)i.next()).startsWith(LExpr.VARPREFIX))
				vcount++;
		if (vcount <= 0)
			return this;
		// ϊrɍꂽϐɒu\ǂׂ.
		if (set.size() > Vcount || vcount > Vcount) {
			//throw new IllegalArgumentException("Sorry, too complex");
			return this;  // rIȒPɋN悤Ȃ̂Œ߂.
		}
		Map map = new HashMap();
		int index = 0;
		for (Iterator i = set.iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			if (!name.startsWith(LExpr.VARPREFIX))
				continue;
			String newname = null;
			while (index < Vcount) {
				newname = String.valueOf(Vchars.charAt(index++));
				if (!set.contains(newname))
					break;
			}
			if (index >= Vcount) {
				//throw new IllegalArgumentException("Sorry, too complex");
				return this;  // ܂ɋN. (Y Combinator gꍇȂ)
			}
			map.put(name, newname);
		}
		// mapQƂĕϐu.
		LExpr newexpr = (LExpr)this.clone();
		newexpr.replaceVars(map);
		return newexpr;
	}

	/*-------------------------------------------------------------------*/
	// _̏o͌`

	private static final String Waste1 = ".\\", Waste2 = "." + LAMBDA;

	/**
	 * o͂郉_L̗̂悤ɏC.
	 *       CO          C
	 *   -------------------------------
	 *     x.y.x(xy) => xy.x(xy)
	 *     \x.\y.x(xy)   => \xy.x(xy)
	 *
	 * ̂悤Ȍ`IȏC͗ǂȂo͒O̕ɑ΂鑀ł
	 * {IȕCCył. ^_^;)
	 */
	protected final String simplify(String s) {
		if (s.indexOf(Waste1) < 0 && s.indexOf(Waste2) < 0)
			return s;
		StringBuffer sb = new StringBuffer(s);
		for ( ; ; ) {
			int off = sb.indexOf(Waste1);
			if (off < 0)
				off = sb.indexOf(Waste2);
			if (off < 0)
				break;
			sb.delete(off, off+2);
		}
		return sb.toString();
	}

	/**
	 * Kv𔻒肵ė^ꂽʂł.
	 * Kv̂ȂꍇƂ
	 *   EP̕ϐ̏ꍇ
	 *   EłɊʂłĂꍇ
	 * Ƃ.
	 * Ƃ
	 *     "(ab)"  "((ab)(cd))"
	 * Ȃǂ͂łɊʂłĂ邪
	 *     "(ab)(cd)"
	 * ͊ʂłĂȂƂɒӂ邱.
	 */
	protected final String parenthesize(String es) {
		if (es.length() < 2 || checkVariable(es))
			return es;  // Pϐ̏ꍇ͏O
		if (es.charAt(0) == '(' && es.charAt(es.length()-1) == ')') {
			int level = 1;
			int off = 1;
			for (int end = es.length()-1; level > 0 && off < end; off++) {
				int c = es.charAt(off);
				if (c == '(')
					level++;
				if (c == ')')
					level--;
			}
			if (level > 0)
				return es;  // łɊʂłĂ.
		}
		return "(" + es + ")";
	}

	/*-------------------------------------------------------------------*/
	// CX^X

	// _̃TuNX̎ʎq
	private static final String
		VAR_ID = "var", ABS_ID = "abs", APP_ID = "app", REDEX_ID = "redex";

	// ftHg̃_TuNX
	private static final String DEFCLASS[][] = {
		{ VAR_ID, "mypkg.lambda.Variable" },
		{ ABS_ID, "mypkg.lambda.Abstraction" },
		{ APP_ID, "mypkg.lambda.Application" },
		{ REDEX_ID, "mypkg.lambda.BetaRedex" },
	};

	// ConstructorLbV}bv (L[̓_̃TuNX̎ʎq)
	private static Map constructorMap = new HashMap();

	/**
	 * ʎqɑΉ郉_IuWFNg쐬.
	 */
	protected static LExpr createObject(String id, Class types[],
			Object args[]) {
		Constructor constructor = (Constructor)constructorMap.get(id);
		try {
			if (constructor == null) {
				Class c = Class.forName(getSubclassName(id));
				constructor = c.getDeclaredConstructor(types);
				constructorMap.put(id, constructor);
			}
			return (LExpr)constructor.newInstance(args);
		} catch (Exception e) {
			e.printStackTrace();
			throw new IllegalStateException("check env");
		}
	}

	/**
	 * TuNX̎ʎqTuNXւ̕ϊ
	 */
	private static String getSubclassName(String id) {
		String propkey = LExpr.class.getName() + "." + id + ".class";
		String className = System.getProperty(propkey);
		if (className != null && className.length() > 0)
			return className;
		for (int n = 0; n < DEFCLASS.length; n++)
			if (id.equals(DEFCLASS[n][0]))
				return DEFCLASS[n][1];
		throw new IllegalStateException("invalid subclass ID: " + id);
	}

	/*-------------------------------------------------------------------*/
	// ̑

	private LinkedList workstack;

	/**
	 * ׂĂ̊Ȗ񌋉ʂ߂ reduceAll() ŌʂXgɋL.
	 * P add() ȂR͏dh߂ł.
	 * dN蓾邩ǂ͓̉͂̂Ō]ɂĖ
	 * `FbN.
	 * ȂƂŕϊsƏd錋ʂoĂ悤ł.
	 */
	protected final void appendLExpr(List list, LExpr expr) {
		if (workstack == null)
			workstack = new LinkedList();
		for (int n = 0; n < list.size(); n++) {
			workstack.clear();
			if (expr.isEquivalent((LExpr)list.get(n), workstack, 0))
				return;
		}
		list.add(expr);
	}
}
