package mypkg.lambda;

/**
 * _vŽvZ
 *
 * _̐K`vZۂɌvZꂽlł͂ȂȖ񐔂⏊vԂ
 * dvȏł. ̃NX͂̏ێ.
 */
public class ResultValue {

	private LExpr value;    // K`̃_
	private int stepCount;  // K`ƂȂ܂ł̊Ȗ
	private long time;      // ~bPʂ̏v

	/**
	 * ׂĂ̏w肵ăIuWFNg쐬.
	 *
	 * @param value K`̃_
	 * @param stepCount K`ƂȂ܂ł̊Ȗ
	 * @param time ~bPʂ̏v
	 */
	public ResultValue(LExpr value, int stepCount, long time) {
		this.value = value;
		this.stepCount = stepCount;
		this.time = time;
	}

	/**
	 * vZꂽlw肵ăIuWFNg쐬.
	 *
	 * @param value K`̃_
	 */
	public ResultValue(LExpr value) {
		this(value, 0, 0);
	}

	/**
	 * ftHgRXgN^
	 */
	public ResultValue() {
		this(null, 0, 0);
	}

	/**
	 * vZ~ꍇtrueԂ.
	 */
	public boolean halted() { return value != null; }

	/**
	 * vZꂽK`̃_Ԃ.
	 */
	public LExpr getValue() { return value; }

	/**
	 * K`ƂȂ܂ł̊Ȗ񐔂Ԃ.
	 */
	public int getStepCount() { return stepCount; }

	/**
	 * ~bPʂ̏vԂԂ.
	 */
	public long getTime() { return time; }

	/**
	 * Ȗ񐔂ƏvԂԂ.
	 */
	public String observedData() {
		StringBuffer sb = new StringBuffer();
		sb.append(stepCount).append(" step(s) [");
		sb.append(getTimeMillis()).append("ms]");
		return sb.toString();
	}

	/**
	 * ~bPʂ̏vԂ\Ԃ.
	 */
	private String getTimeMillis() {
		StringBuffer sb = new StringBuffer();
		sb.append(time);
		switch (sb.length()) {
		case 1:
			sb.insert(0, "0.00");
			break;
		case 2:
			sb.insert(0, "0.0");
			break;
		case 3:
			sb.insert(0, "0.");
			break;
		default:
			sb.insert(sb.length()-3, ".");
			break;
		}
		return sb.toString();
	}
}
